(function () {


  var div = document.createElement('div');

  div.setAttribute('class', 'bv-light_2018');

  if (window.classroomToolshasSlideRun) {
    document.body.appendChild(div);
    makeHandlers();
    return;
  }
  window.classroomToolshasSlideRun = true;

  document.body.appendChild(div);

  function mouseover(e) {
    var rect = e.target.getBoundingClientRect();
    div.style.left = rect.left + 'px';
    div.style.top = rect.top + 'px';
    div.style.width = rect.width + 'px';
    div.style.height = rect.height + 'px';
    div.style.display = 'block';
  }

  function click(e) {

    e.stopImmediatePropagation();
    e.preventDefault();
    if (e.target.tagName != "HTML") {
      e.target.style.visibility = "hidden";
    }

  }

  function listenToOff(message) {
    if (message.command == "hide") {
      cleanHouse();
    }
  }

  function keyHandler(e) {
    if (e.key === "Escape") {
      cleanHouse();
    }
  }

  function cleanHouse() {

    document.removeEventListener('click', click, true);
    document.removeEventListener('mouseover', mouseover);
    document.removeEventListener("keypress", keyHandler, true);

    if (div.parentElement) {
      div.parentElement.removeChild(div);
    }
  }

  function makeHandlers() {
    document.addEventListener('mouseover', mouseover);
    document.addEventListener('click', click, true);
    document.addEventListener("keyup", keyHandler, true);
    chrome.runtime.onMessage.addListener(listenToOff);
  }
  makeHandlers();


})();