(function() {
  'use strict';

  if(document.getElementById("a12s3dFM53n-a12s3dFM53n")!=null){
    chrome.runtime.sendMessage({hasDiv: true});

  }
 
 if (window.classroomToolsHasSlideRun) {
    return;
  }
  window.classroomToolsHasSlideRun = true;

  chrome.runtime.onMessage.addListener(listenToPopup);


function listenToPopup(message){
  setTheme(message.colourscheme);

  
    if (message.command == "window") {
          mode = "window";
          clearDiv();
          removeListeners();
          buildWindow();
    } else if (message.command == "slide") {
        mode = "slider";
        clearDiv();
        removeListeners();
        buildSlider();
    }else if (message.command == "close") {
      closeMask();
  }



  }

var marginTop =0, marginRight = 0,marginBottom =0, marginLeft = 0;
var maskWidth = winWidth;
var maskHeight = winHeight;
var stopDistance = 50;
var mode;
var svgX = 100, svgY = 100, svgWidth = 100, svgHeight = 100;
var svgBottom = 0;
var tempDragX, tempDragY, dragPointX, dragPointY, mouseX, mouseY;
var isdragging = false, ismoving = false;
var imgsrc, closesrc, dragsrc, maskColour, resizesrc, fullsizesrc;
var curtarget;
var dragSize = 22;
var sideDragLong = 37;
var sideDragShort = 18;
var handlesize = 22;

var dragT = document.createElement("img");
var dragR = document.createElement("img");
var dragB = document.createElement("img");
var dragL = document.createElement("img");
var wholeDrag = document.createElement("img");
var close = document.createElement("img");
var sizer = document.createElement("img");
var sizerTR = document.createElement("img");
var fullsizeBT = document.createElement("img");

var list = document.getElementsByTagName('body');
var mask = document.createElement("div");
var svgDiv = document.createElement("div");
var handleXOff = 0;
var handleYOff = 0;

var windowElList = [svgDiv,close, sizer, sizerTR, wholeDrag];
var sliderElList = [dragT,dragR,dragB, dragL, wholeDrag, close,sizer,fullsizeBT];

var scrollbarMargin, bottomScrollbarMargin, docHeight, docWidth, winHeight, winWidth;
var body = document.body,
  html = document.documentElement;



mask.setAttribute("id", "a12s3dFM53n-a12s3dFM53n");

scrollbarCheck();


function setTheme(theme){
  
  if (theme == "light") {
    
    maskColour = "#f0f0f0";

  } else if (theme == "dark"){

    maskColour = "#000000";

  }

  imgsrc = chrome.extension.getURL("image/drag-"+theme+".png");
  closesrc = chrome.extension.getURL("image/close-"+theme+".png");
  dragsrc = chrome.extension.getURL("image/drag-"+theme+"-whole.png");
  resizesrc = chrome.extension.getURL("image/resize-"+theme+".png");
  fullsizesrc = chrome.extension.getURL("image/full-"+theme+".png");
}

function clearDiv(){
  mask.innerHTML = "";
}


function buildSlider(){

   resetMargins();

   for (var i = 0; i < sliderElList.length; i++) {
    mask.appendChild(sliderElList[i]);
     
   }
   

  fullsizeBT.setAttribute('src', fullsizesrc);
  fullsizeBT.setAttribute("style", "position:absolute;right:0; transform:translateX(-26px);height:"+dragSize+"px;width:"+dragSize+"px;");
  fullsizeBT.setAttribute("id", "drag_fullsize");

  sizer.setAttribute('src', resizesrc);
  sizer.setAttribute("style", "position:absolute;top:100%;right:0; transform:translateY(-22px);height:"+dragSize+"px;width:"+dragSize+"px;");
  sizer.setAttribute("id", "drag_resize");

  wholeDrag.setAttribute('src', dragsrc);
  wholeDrag.setAttribute("style", "position:absolute;height:"+dragSize+"px;width:"+dragSize+"px;");
  wholeDrag.setAttribute("id", "drag_whole");

  close.setAttribute('src', closesrc);
  close.setAttribute("style", "position:absolute;left:100%;transform: translateX(-22px);height:"+dragSize+"px;width:"+dragSize+"px;");
  close.setAttribute("id", "close_mask");

  dragT.setAttribute('src', imgsrc);
  dragT.setAttribute("style", "position:absolute;left:50%;transform: translateX(-18px);height:"+sideDragShort+"px;width:"+sideDragLong+"px;");
  dragT.setAttribute("id", "drag_top");

  dragR.setAttribute('src', imgsrc);
  dragR.setAttribute("style", "position:absolute;top:50%;right:0; transform:translate(9px) rotate(0.25turn);height:"+sideDragShort+"px;width:"+sideDragLong+"px;");
  dragR.setAttribute("id", "drag_right");

  dragB.setAttribute('src', imgsrc);
  dragB.setAttribute("style", "position:absolute;bottom:0;left:50%;transform: translateX(-18px) rotate(0.5turn);height:"+sideDragShort+"px;width:"+sideDragLong+"px ;");
  dragB.setAttribute("id", "drag_bottom");

  dragL.setAttribute('src', imgsrc);
  dragL.setAttribute("style", "position:absolute;float:left;top:50%; transform:translateX(-9px) rotate(0.75turn) ;height:"+sideDragShort+"px;width:"+sideDragLong+"px;");
  dragL.setAttribute("id", "drag_left");

  list[0].appendChild(mask);

  mask.setAttribute("style", "position:fixed;z-index:99999999998;left:0px;top:0px;width:" + (winWidth - scrollbarMargin) + "px;height:" + (winHeight - bottomScrollbarMargin) + "px;background-color:" + maskColour + ";");

  addListeners();
}


function removeListeners(){

  document.removeEventListener('mousemove', onMouseMove);
  window.removeEventListener('resize', onScrollOrResize);
  document.removeEventListener('mouseup', onRelease);
  mask.removeEventListener('mouseover', dragHover);
  mask.removeEventListener('mousedown', onMouseDown);
  if(mode =="slider"){
    window.removeEventListener('scroll', onScrollOrResize);
  }

}
function addListeners() {
  
  document.addEventListener('mousemove', onMouseMove);
  window.addEventListener('resize', onScrollOrResize);
  document.addEventListener('mouseup', onRelease);
  mask.addEventListener('mouseover', dragHover);
  mask.addEventListener('mousedown', onMouseDown);
  if(mode =="slider"){
    window.addEventListener('scroll', onScrollOrResize);
  }
}


function buildWindow(){

  svgX = 100;
  svgY = 100;
  svgWidth = 100;
  svgHeight = 100;
  drawSVGSquare();

  for (var i = 0; i < windowElList.length; i++) {
    mask.appendChild(windowElList[i]);
   }


  svgDiv.setAttribute("style", "position:absolute; width:100%;height:100%; ");
  svgDiv.setAttribute("id", "svg_div");


  sizer.setAttribute('src', resizesrc);
  sizer.setAttribute("style", "position:absolute;top:"+(svgY+svgHeight)+"px;left:"+(svgX+svgWidth)+"px;pointer-events:auto;height:"+dragSize+"px;width:"+dragSize+"px;");
  sizer.setAttribute("id", "drag_resize");

  sizerTR.setAttribute('src', resizesrc);
  sizerTR.setAttribute("style", "position:absolute;top:"+(svgY-handlesize)+"px;left:"+(svgX+svgWidth)+"px;pointer-events:auto;height:"+dragSize+"px;width:"+dragSize+"px;");
  sizerTR.setAttribute("id", "drag_resizeTR");


  wholeDrag.setAttribute('src', dragsrc);
  wholeDrag.setAttribute("style", "position:absolute;top:"+(svgY-handlesize)+"px;left:"+(svgX-handlesize)+"px;pointer-events:auto;height:"+dragSize+"px;width:"+dragSize+"px;");
  wholeDrag.setAttribute("id", "drag_whole");

  close.setAttribute('src', closesrc);
  close.setAttribute("style", "position:absolute;left:100%;transform: translateX(-22px);pointer-events:auto;height:"+dragSize+"px;width:"+dragSize+"px;");
  close.setAttribute("id", "close_mask");

  list[0].appendChild(mask);
  mask.setAttribute("style", 'position:fixed;z-index:999999999998;left:0px;top:0px;width:100%;height:100%;pointer-events:none; ');

  addListeners();

}

function drawSVGSquare(){
  
  svgDiv.innerHTML = "<svg width=100% height=100% > <g fill-rule='evenodd' fill='"+maskColour+"' ><path d='M0 0 V "+winHeight+" H  "+winWidth+" V 0z M "+(svgX)+","+(svgY)+" H "+(svgX+svgWidth)+" V "+(svgY+svgHeight)+" H "+svgX+"  z ' /></svg>";
}



function scrollbarCheck() {
 
  winHeight = window.innerHeight;
  winWidth = window.innerWidth;
  docHeight = Math.max(body.scrollHeight, body.offsetHeight,
    html.clientHeight, html.scrollHeight, html.offsetHeight);
  docWidth = Math.max(body.scrollWidth, body.offsetWidth,
    html.clientWidth, html.scrollWidth, html.offsetWidth);

  scrollbarMargin = window.innerWidth - document.documentElement.clientWidth;
  bottomScrollbarMargin = window.innerHeight - document.documentElement.clientHeight;
}





function closeMask() {

  mask.parentNode.removeChild(mask);
}

function dragHover(e) {
  if(e.target.parentElement.id == 'a12s3dFM53n-a12s3dFM53n' && e.target.id !="svg_div" )
    e.target.style.cursor = "pointer";
}


function resetMargins() {
  marginLeft = 0;
  marginRight = 0;
  marginTop = 0;
  marginBottom = 0;
  maskWidth = window.innerWidth;
  maskHeight = window.innerHeight;
  
}


function onMouseDown(e) {
  svgBottom = svgY+svgHeight;
  curtarget = e.target.id;
  if (curtarget == "drag_fullsize") {
    resetMargins();
    updateSlideMask();
  }

  if (curtarget == "close_mask") {
      closeMask();
  }

  if (curtarget == "drag_whole") {

      if(mode =="slider"){
        if (maskWidth < winWidth || maskHeight < winHeight) {

          ismoving = true;
          tempDragX = mouseX;
          tempDragY = mouseY;
          dragPointX = mouseX - marginLeft;
          dragPointY = mouseY - marginTop;
        }
      }

    if(mode =="window"){
      var rect = wholeDrag.getBoundingClientRect();
      handleXOff = Math.abs(mouseX - rect.right);
      handleYOff = Math.abs(mouseY - rect.bottom);
    }
    
  }
    if(e.target.parentElement.id == 'a12s3dFM53n-a12s3dFM53n'){
    isdragging = true;

}
  e.preventDefault();
}

function onRelease(e) {

  if (ismoving) {
    marginRight += tempDragX - marginLeft - dragPointX;
    marginBottom += tempDragY - marginTop - dragPointY;
  }
  isdragging = false;
  ismoving = false;
  curtarget = 0;

}


function onMouseMove(e) {

  mouseX = e.pageX - window.scrollX;
  mouseY = e.pageY - window.scrollY;


    if (isdragging) {

        if(mode =="slider"){

          switch (curtarget) {

            case "drag_top":

              marginTop = mouseY;
              if (mouseY < 0) {
                marginTop = 0;
              }
              if (mouseY > winHeight - (marginBottom + stopDistance)) {
                marginTop = winHeight - (marginBottom + stopDistance);
              }
              break;


            case "drag_bottom":

              marginBottom = (winHeight) - mouseY - bottomScrollbarMargin;
              if (mouseY > (winHeight) - bottomScrollbarMargin) {
                marginBottom = 0;
              }
              if (mouseY < marginTop + stopDistance) {
                marginBottom = winHeight - (marginTop + stopDistance);
              }
              break;

            case "drag_right":

              marginRight = (winWidth - mouseX) - scrollbarMargin;
              if (mouseX > winWidth - scrollbarMargin) {
                marginRight = 0;
              }
              if (mouseX < marginLeft + stopDistance) {
                marginRight = winWidth - (marginLeft + stopDistance);
              }
              break;


            case "drag_left":

              marginLeft = mouseX;
              if (mouseX < 0) {
                marginLeft = 0;
              }
              if (mouseX > winWidth - stopDistance - marginRight) {
                marginLeft = winWidth - stopDistance - marginRight;
              }
              break;


            case "drag_resize":

              marginRight = (winWidth - mouseX) - scrollbarMargin;
              if (mouseX > winWidth - scrollbarMargin) {
                marginRight = 0;
              }
              if (mouseX < marginLeft + stopDistance) {
                marginRight = winWidth - (marginLeft + stopDistance);
              }
              marginBottom = (winHeight) - mouseY - bottomScrollbarMargin;
              if (mouseY > (winHeight) - bottomScrollbarMargin) {
                marginBottom = 0;
              }
              if (mouseY < marginTop + stopDistance) {
                marginBottom = winHeight - (marginTop + stopDistance);
              }
              break;

            case "drag_whole":

              if (ismoving) {

                if (mouseX < 0) {
                  marginLeft = 0;
                } else {
                  marginLeft = mouseX - dragPointX;
                }

                if (mouseX > winWidth - maskWidth) {
                  marginLeft = winWidth - maskWidth;
                } else if (mouseX > 0) {
                  marginLeft = mouseX - dragPointX;
                }

                if (mouseY < 0) {
                  marginTop = 0;
                } else {
                  marginTop = mouseY - dragPointY;
                }

                if (mouseY > winHeight - maskHeight) {
                  marginTop = winHeight - maskHeight;
                } else if (mouseY > 0) {
                  marginTop = mouseY - dragPointY;
                }
              }
              break;

            default:
              break;

          }
          updateSlideMask();
        }

          if(mode =="window"){

                switch (curtarget) {

                  case "drag_whole":

                  var dragX;
                  var dragY;

                if(mouseX< (0+(handlesize-handleXOff)))
                {
                    svgX= 0+handlesize;
                    dragX = 0;
                 
                }else if(mouseX> winWidth-handleXOff){

                    svgX = winWidth-scrollbarMargin;
                    dragX = winWidth-(handlesize+scrollbarMargin);
                    
                }else {

                    svgX = mouseX+handleXOff;
                    dragX = mouseX-(handlesize-handleXOff);                    
                }



                if(mouseY< (0+(handlesize-handleYOff)))
                {
                    svgY= 0+handlesize;
                    dragY = 0;
                 
                }else if(mouseY> winHeight-handleYOff){

                    svgY = winHeight-bottomScrollbarMargin;
                    dragY = winHeight-(handlesize+bottomScrollbarMargin);

                }else {

                    svgY = mouseY+handleYOff;
                    dragY = mouseY-(handlesize-handleYOff);
                }


                positionWholeDrag(dragX, dragY);

                sizer.setAttribute("style", "position:absolute;top:"+(svgY+svgHeight)+"px;left:"+(svgX+svgWidth)+"px;pointer-events:auto;height:"+dragSize+"px;width:"+dragSize+"px;");

                sizerTR.setAttribute("style", "position:absolute;top:"+(svgY-handlesize)+"px;left:"+(svgX+svgWidth)+"px;pointer-events:auto;height:"+dragSize+"px;width:"+dragSize+"px;");

                drawSVGSquare();

                    break;

                  case "drag_resize":
                      svgWidth =  mouseX - svgX;
                      svgHeight =  mouseY-svgY;

                      sizer.setAttribute("style", "position:absolute;top:"+(svgY+svgHeight)+"px;left:"+(svgX+svgWidth)+"px;pointer-events:auto;height:"+dragSize+"px;width:"+dragSize+"px;");

                      sizerTR.setAttribute("style", "position:absolute;top:"+(svgY-handlesize)+"px;left:"+(svgX+svgWidth)+"px;pointer-events:auto;height:"+dragSize+"px;width:"+dragSize+"px;");

                      drawSVGSquare();

                    break;

                  case "drag_resizeTR":

                      svgY = mouseY;                 
                      svgWidth =  mouseX - svgX;
                      svgHeight =  svgBottom-mouseY;

                      wholeDrag.setAttribute("style", "position:absolute;left:"+(svgX-(handlesize))+"px;top:"+(svgY-(handlesize))+"px;pointer-events:auto;height:"+dragSize+"px;width:"+dragSize+"px;");

                      sizer.setAttribute("style", "position:absolute;top:"+(svgY+svgHeight)+"px;left:"+(svgX+svgWidth)+"px;pointer-events:auto;height:"+dragSize+"px;width:"+dragSize+"px;");

                      sizerTR.setAttribute("style", "position:absolute;top:"+(svgY-handlesize)+"px;left:"+(svgX+svgWidth)+"px;pointer-events:auto;height:"+dragSize+"px;width:"+dragSize+"px;");

                      drawSVGSquare();

                  break;


                  default:
                    break;

          }
      }
}
}

function positionWholeDrag(mx,my){


    wholeDrag.setAttribute("style", "position:absolute;left:"+mx+"px;top:"+my+"px;pointer-events:auto;height:"+dragSize+"px;width:"+dragSize+"px;");
}

function onScrollOrResize() {


  scrollbarCheck();

  winHeight = window.innerHeight;
  winWidth = window.innerWidth;
  drawSVGSquare();
  if(mode == "slider"){
  updateSlideMask();
}
}

function updateSlideMask() {

  if (!ismoving) {

    maskWidth = window.innerWidth - marginLeft - marginRight;
    maskHeight = window.innerHeight - marginTop - marginBottom;
  }

  mask.style.top = marginTop + "px";
  mask.style.left = marginLeft + "px";
  mask.style.width = maskWidth - scrollbarMargin + "px";
  mask.style.height = maskHeight - bottomScrollbarMargin + "px";

}

})();
