
(function () {
	'use strict';	


	
	var mytabs;
	var theme;
	var navbar = document.getElementById("nav");
	var tabList = ["mask", "cover","edit"];
	localStorage.setItem('hasMask', "false");
	
	

	chrome.runtime.onMessage.addListener(
		function listenToContent(message){
			localStorage.setItem('hasMask', "true");	
		});





	chrome.tabs.query({
		active: true, currentWindow: true},
		function (tabs) {
			mytabs = tabs;
			chrome.tabs.executeScript(
				tabs[0].id,
				{file: "/content_scripts/runner.js"},
				function(){setupPopupListeners();}
		);
	});

	setupPopup();



	function setupPopupListeners() {

		
		chrome.tabs.sendMessage(mytabs[0].id, {
			command: "hide"});

		chrome.tabs.executeScript(mytabs[0].id, {code: 'document.getElementsByTagName("body")[0].setAttribute("contenteditable", "false");'});

		chrome.tabs.executeScript(mytabs[0].id, {code: ' removeListeners()'});

		navbar.addEventListener('click', onNavClick);
		document.getElementById('hidercheckbox').checked = false;
		document.addEventListener('click', onMaskSelect);
		document.getElementById('theme').addEventListener('change', onThemeChange);
		document.getElementById('hideswitch').addEventListener('change', onHiderSwitch);
		document.getElementById('editswitch').addEventListener('change', onEditSwitch);
		showTab();
		}




	function setupPopup(){

		if(localStorage.getItem('themecol')=="dark"){
			document.getElementById('light').checked = false;
			document.getElementById('dark').checked = true;
			document.getElementById('theme').setAttribute(
			"style", "background-color: rgb(44, 44, 44); color:#ffffff;");
		}
		document.getElementById('hidercheckbox').checked = false;			
	}
	



	function showTab(){
		var tab = localStorage.getItem('tab');

		var hasMask = localStorage.getItem('hasMask');

	
		

		if(tab!=null){	
	
			for(var i=0;i<tabList.length;i++){
				document.getElementById(tabList[i]+'-content').style.display = 'none';
				document.getElementById(tabList[i]+'-tab').className = '';
				document.getElementById('remove-content').style.display = 'none';
			}

				if( (hasMask=="true")  && (tab =='cover' || tab =='edit')){
					document.getElementById('remove-content').style.display = 'block';
				} else{
			document.getElementById(tab+'-content').style.display = 'block';
			
				}
				document.getElementById(tab+'-tab').className = 'active';  
		}

		
	}


	function onNavClick(e){
		var tab= e.target.id.slice(0,-4);
		localStorage.setItem('tab', tab);		
		showTab();	
	}





	function onThemeChange(e){

		if(e.target.value=="light"){

			document.getElementById('theme').setAttribute(
				"style",
				"background-color: rgb(248, 246, 238);color: #000000;");
			localStorage.setItem('themecol', "light");

		}else{

			document.getElementById('theme').setAttribute("style", "background-color: rgb(44, 44, 44); color:#ffffff;");
			localStorage.setItem('themecol', "dark");
		}
	}
	
	function onHiderSwitch(e){
		
		chrome.tabs.executeScript(mytabs[0].id, {file:"content_scripts/hider.js"});

		chrome.tabs.insertCSS(mytabs[0].id, {file:'content_scripts/styles.css'});
			

		setTimeout(function(){ window.close();},380);

	}	

	function onEditSwitch(e){
		
		chrome.tabs.executeScript(mytabs[0].id, {file: 'content_scripts/edit.js'});

		setTimeout(function(){ window.close();},400);

	}


	function onMaskSelect(e) {
		
		if (e.target.id === "slide") {
			theme = document.querySelector('input[type=radio]:checked').value;
			chrome.tabs.sendMessage(mytabs[0].id, {
				command: "slide",
				colourscheme: theme});

			window.close();

		}else if (e.target.id === "window") {
			theme = document.querySelector('input[type=radio]:checked').value;
			chrome.tabs.sendMessage(mytabs[0].id, {
				command: "window",
				colourscheme: theme});
				
			window.close();
		}else if (e.target.id === "close") {

				
				chrome.tabs.sendMessage(mytabs[0].id, {
					command: "close"});
					localStorage.setItem('hasMask', "false");
					showTab();
				

		}
		else if (e.target.id === "continue") {

			window.close();
				
		}
		
		
	}


})();